"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generatePackageJson = void 0;
const fs = require("fs");
const path_1 = require("path");
const fileutils_1 = require("@nrwl/workspace/src/utils/fileutils");
const generatePackageJson = (project, options, workspaceRoot) => {
    const dependencies = {};
    const buildFile = fs.readFileSync(`${options.outputPath}/main.js`, 'utf8');
    const re2 = /"(.*)"/gm;
    const externalDependencies = buildFile.match(/require\("(.*)"\)/gm);
    // Get the package version from the root
    if (externalDependencies) {
        const workspacePackages = fileutils_1.readJsonFile(path_1.join(workspaceRoot, 'package.json'));
        const dependenciesName = externalDependencies.map((x) => x.match(re2)[0].replace(/"/gm, ''));
        dependenciesName.forEach((dep) => {
            const packageIsDefined = dep in workspacePackages.dependencies;
            dependencies[dep] = packageIsDefined
                ? workspacePackages.dependencies[dep]
                : '*';
        });
    }
    const packageJson = path_1.join(options.projectRoot, 'package.json');
    const originalPackageJson = fileutils_1.fileExists(packageJson)
        ? fileutils_1.readJsonFile(packageJson)
        : { dependencies: {} };
    originalPackageJson.dependencies = Object.assign(Object.assign({}, originalPackageJson.dependencies), externalDependencies);
    fileutils_1.writeToFile(path_1.join(options.outputPath, 'package.json'), JSON.stringify(originalPackageJson, null, 2));
};
exports.generatePackageJson = generatePackageJson;
//# sourceMappingURL=generate-package-json.js.map